#include <vector>
#include <iostream>

#include <boost/msm/back/state_machine.hpp>
#include <boost/msm/front/euml/euml.hpp>

using namespace std;
using namespace boost::msm::front::euml;
namespace msm = boost::msm;

namespace MSM_A // Concrete FSM implementation
{
	BOOST_MSM_EUML_DECLARE_ATTRIBUTE(int, borrowedBuffer_attribute);

	BOOST_MSM_EUML_ACTION(someAction)
	{
		template <class Event,class FSM,class STATE>
		void operator()(Event const& event,FSM& fsm, STATE&)
		{
			fsm.get_attribute(borrowedBuffer_attribute)=1;		// <--------------- UNCOMMENTING THIS WILL ALSO ALLOW COMPILATION
		}
	};

	BOOST_MSM_EUML_EVENT(someevent)

	BOOST_MSM_EUML_STATE((no_action), someStateA) 
    BOOST_MSM_EUML_STATE((no_action), someStateB)

	BOOST_MSM_EUML_TRANSITION_TABLE((
		  someStateA + someevent == someStateB
          ),transition_table)

    BOOST_MSM_EUML_DECLARE_STATE_MACHINE(( transition_table,
                                    init_ << someStateA,
                                    someAction,  // <-------------------- ACTION IS AN ENTRY ACTION
                                    no_action,
                                    attributes_ << borrowedBuffer_attribute,
									configure_ << no_configure_ 
                                    ),
									MSM_A_frontEnd) //fsm name
	typedef msm::back::state_machine<MSM_A_frontEnd> MSM_A_player;
}


namespace MSM_B // Concrete FSM implementation
{
	::MSM_A::MSM_A_player subMachine;
	BOOST_MSM_EUML_EVENT(someEvent)
	BOOST_MSM_EUML_STATE((no_action), someState)
    BOOST_MSM_EUML_TRANSITION_TABLE((
		someState + someEvent == subMachine
	), transition_table)
    BOOST_MSM_EUML_DECLARE_STATE_MACHINE((	transition_table, //STT
											//init_ << someState, // <---------------- WORKS
											init_ << subMachine, // <---------------- DOES NOT COMPILE
											no_action, // Entry
											no_action, // Exit
											attributes_ << no_attributes_, // Attributes
											configure_ << no_configure_
											),
											MSM_B_frontEnd) //fsm name

    typedef msm::back::state_machine<MSM_B_frontEnd> MSM_B_player;
}

int main()
{

    MSM_B::MSM_B_player player;
	player.start();
	return 0;
}